//
//  Generala.swift
//  Generala
//
//  Created by Nicolas Gauna on 4/13/20.
//  Copyright © 2020 Nicolas Gauna. All rights reserved.
//

import Foundation
class Generala { //Esta es mi clase Generala
    var jugadaResultante : String = ""
    
    func jugada(dados:String) -> String{
        if(generala(dadosTirados: dados)){ jugadaResultante = "generala"}
        if(poker(dadosTirados: dados)){ jugadaResultante = "poker"}
        if(full(dadosTirados: dados)){ jugadaResultante = "full"}
        if(escalera(dadosTirados: dados)){ jugadaResultante = "escalera" }
        if(invalido(dadosTirados: dados)){ jugadaResultante = "invalido"}
        if(jugadaResultante == ""){jugadaResultante = "Nada"}
        return jugadaResultante
    }
    
    
    func generala (dadosTirados:String) -> Bool{
        //1. GENERALA
        //Todos los dados, con el mismo valor. Ejemplo: 55555
        switch dadosTirados {
        case "11111", "22222", "33333", "44444", "55555", "66666" : //Si es igual a uno de estos casos
            return true //retornamos true
        default:
            return false //Si no es igual retornamos false
        }
    }
    
    func poker(dadosTirados:String) -> Bool{
        //2. PÓKER
        //Cuatro dados con el mismo valor. Ejemplo: 55553
        var bool : Bool = false
        var vec : [Int] = [0,0,0,0,0,0,0]
        for caracter in dadosTirados{
            switch caracter {
            case "1" : vec[1] += 1
            case "2" : vec[2] += 1
            case "3" : vec[3] += 1
            case "4" : vec[4] += 1
            case "5" : vec[5] += 1
            case "6" : vec[6] += 1
            default  : vec[0] += 1
            }
        }
        for i in 1...6{
            if (vec[i] == 4) { bool = true }
        }
        return bool
    }
    
    func full(dadosTirados:String) -> Bool{
        //3. FULL
        //Tres dados con el mismo valor y los otros dos, de un mismo valor
        //Ejemplo: 55533
        var bool : Bool = false
        var temp : Int
        var vec : [Int] = [0,0,0,0,0,0,0]
        for caracter in dadosTirados{
            switch caracter {
            case "1" : vec[1] += 1
            case "2" : vec[2] += 1
            case "3" : vec[3] += 1
            case "4" : vec[4] += 1
            case "5" : vec[5] += 1
            case "6" : vec[6] += 1
            default  : vec[0] += 1
            }
        }
        for i in 1...6{
            if (vec[i] == 3) {
                temp = i
                for a in 1...6{
                    if (vec[a] == 2 && vec[a] != temp) { bool = true }
                }
            }
        }
        
        return bool
        
    }
    func escalera(dadosTirados:String) -> Bool{
        //4. ESCALERA
        //Los dados, en secuencia:
        //    a) 12345
        //    b) 23456
        //    c) 34561
        let dado = String(dadosTirados.sorted())
        switch dado {
        case "12345", "23456", "34561", "45612","56123", "61234" :
            return  true
        default:
            return false
        }
    }
    
    func invalido(dadosTirados:String) -> Bool{
        //6. INVALIDO
        //Hay algún valor inválido en los dados ingresados.
        var bool : Bool = false
        for caracter in dadosTirados{
            if (caracter > "6") { bool = true } else {bool = false}
        }
        return bool
    }
}
