//
//  ViewController.swift
//  Generala
//
//  Created by Nicolas Gauna on 4/13/20.
//  Copyright © 2020 Nicolas Gauna. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    @IBOutlet weak var imgView1: UIImageView!
    @IBOutlet weak var imgView2: UIImageView!
    @IBOutlet weak var imgView3: UIImageView!
    @IBOutlet weak var imgView4: UIImageView!
    @IBOutlet weak var imgView5: UIImageView!
    
    @IBOutlet weak var lblResultado: UILabel!
    @IBOutlet weak var txtFieldDado: UITextField!
    var resultadoDado: String = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        
    }
    func aleatorio()->String{
        var rand = 0
        while (rand == 0) {
            rand = Int(arc4random_uniform(6)) // numero random en base a 10
            //let rand2 = Int(arc4random()) // numero random
        }
        return String(rand)
    }
    
    @IBAction func generala(_ sender: Any) {
        var numerosParaLasImagenes = ["","","","",""]
        if (txtFieldDado.text == "" || txtFieldDado.text == resultadoDado){
            txtFieldDado.text = ""
            for i in 0...4{
                let numeroAleatorio = aleatorio()
                txtFieldDado.text?.append(numeroAleatorio)
                numerosParaLasImagenes[i] = numeroAleatorio
            }
        } else {
            var cont = 0
            var cont2 = ["","","","",""]
            if(txtFieldDado.text!.count > 5 || txtFieldDado.text!.count < 5){
                lblResultado.text = ""
                return
            }
            for caracter in txtFieldDado.text!{
                cont2[cont] = String(caracter)
                
                cont += 1
            }
            for i in 0...4{ numerosParaLasImagenes[i] = cont2[i]}
            
            
        }
        
        imgView1.image = UIImage(named: "\(numerosParaLasImagenes[0]).jpg")
        imgView2.image = UIImage(named: "\(numerosParaLasImagenes[1]).jpg")
        imgView3.image = UIImage(named: "\(numerosParaLasImagenes[2]).jpg")
        imgView4.image = UIImage(named: "\(numerosParaLasImagenes[3]).jpg")
        imgView5.image = UIImage(named: "\(numerosParaLasImagenes[4]).jpg")
        
        resultadoDado = String(txtFieldDado.text!)
        let generala = Generala()
        let tipoJugada = generala.jugada(dados: resultadoDado)
        lblResultado.text = tipoJugada
        print("\(resultadoDado) - \(tipoJugada)")
        
        
    }
    
    


}

